# BearMetal PDF Tools

A collection of tools for working with PDF forms.

## Features

- Check Code Tool
  - reads supplied code files to see if form fields are present and represented
    in a switch statement
- Field Rename Tool
  - provide a search and replace pattern to bulk rename form fields
- List Form Fields
  - Sometimes you just need to see what fields there are

## Prereqs

Deno >=2.2 (not required if downloading .exe)

## Installation

### Deno install

`deno install -g --allow-read --allow-write --allow-net --allow-env jsr:@bearmetal/pdf-tools`
-> installs as global command `pdf-tools`

### Compile

`deno task compile` -> compare-form-fields.exe -OR- Download .exe from release

> If you want it to be a global command, create an executables directory and add
> it to the PATH

### Precompiled

Download the latest release from the
[releases page](https://git.cyborggrizzly.com/BearMetal/pdf-tools/releases)

## Usage

`pdf-tools <tool> <args>` -> `<tool>` is one of the following

- check-code
- field-rename
- list-form-fields

## Contributing

Contributions are welcome!

## License

GPL 3.0

---

### About this project

BearMetal PDF Tools is a collection of tools made to fix the current state of
PDF form editing. Adobe Acrobat is a great tool, but it's not always the easiest
to use, nor is it free. It also lacks some features that I find useful, such as
bulk renaming of form fields. There's also a lack of powerful, free, and open
source tools for PDF editing.

This project aims to fill that gap by providing a set of tools that can be used
to edit PDF forms. The tools are written in Deno, a modern and secure runtime
for JavaScript and TypeScript. They are designed to be easy to use and to
provide a great user experience.

The tools are designed to be used in a terminal, and are not designed to be
integrated into other applications. They are also not designed to be used as a
library, but rather as a command line tool.

### About BearMetal

BearMetal is a project that aims to decrapify modern web development. It is a
collection of tools, libraries, and resources that aim to make web development
more accessible and less intimidating. The project is open source and free to
use, and is designed to be used by anyone, regardless of skill level or
experience. You can find a list of libraries and tools on
[JSR](https://jsr.io/@bearmetal).
